require "time"
require "json"

module CWLLogger

  # Sets the app name
  def self.app_name=(value)
    @app_name = value
  end

  # Returns the app name. Defaults to the value in ENV['APP']
  def self.app_name
    @app_name || ENV["APP"] || "unset"
  end

  # Writes a new log message. Takes args, a hash of keys and values that
  # should be written
  def self.log(event, args = {})
    data = {}
    data["app"] = app_name
    data["time"] = Time.now.utc.strftime("%FT%T")
    data["event"] = event

    puts JSON.dump(data.merge(args))
  end
end
