require "benchmark"
require_relative "../cwllogger"

module CWLLogger
  class Middleware
    def initialize(app)
      @app = app
    end

    def call(env)
      dup._call(env)
    end

    def _call(env)
      req = Rack::Request.new(env)
      result = []

      time = Benchmark.realtime do
        result = @app.call(env)
      end

      CWLLogger.log("http-request", {
        method: env["REQUEST_METHOD"],
        url: req.url,
        status: result[0],
        duration: time * 1000
      })

      result
    end
  end
end
